/**
 *      evaluation.c
 *      Fonction d'évaluation
 *
 *      Mathieu Pellegrin
 *
 *      2009
 *
 **/

/* Inclusions standard */
#include <stdlib.h>
#include <stdio.h>

/* Inclusions du programme */
#include "../typedef.h"


/* Fonction d'évaluation
 * Auteur: Mathieu Pellegrin
 * Entrée: Le damier en l'état actuel
 * Sortie: Evaluation de la position actuelle
 */
int evaluation(Tdamier dm)
{
	int x,y;
	int e = 0;
	int add = 0;
	int signe;

	for (x=0; x<tailleDamier; x++)
	{
		for (y=0; y<tailleDamier; y++)
		{
			if (dm[x][y].coul == 'B')
				signe = 1;
			else
				signe = -1;
			if (dm[x][y].coul != 'V')
			{
				if (dm[x][y].piece == 'P')
					add = signe*1;
				if (dm[x][y].piece == 'D')
					add = signe*3;
				if (x==0 || x==tailleDamier-1 || y==0 || y==tailleDamier-1)
					add = add + signe*1;
				e += add;
			}
		}
	}
	return e;
}
