/**
 *      help_about.c
 *      Contient les callbacks pour les menus "Aide" et "A Propos"
 *
 *      Mathieu Pellegrin
 *
 *      2009
 *
 **/

/* Inclusions standard */
#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>

/* Inclusions du programme */
#include "../../typedef.h"
#include "../../common.h"
#include "../common_interface.h"
/*#include "interface_gtk.h"*/
#include "callback.h"
#include "help_about.h"


/* Fonction de callback pour pour le menu "Aide"
 * Auteur: Mathieu Pellegrin
 * Entrée: Rien
 * Sortie: Rien
 */
void cb_menu_help (void)
{
	GtkWidget *p_dialog = NULL;

	p_dialog = gtk_message_dialog_new(NULL, GTK_DIALOG_MODAL, GTK_MESSAGE_INFO, GTK_BUTTONS_OK, "Pour plus de renseignements, veuillez lire le manuel utilisateur qui se trouve dans le dossier doc.");
	gtk_dialog_run (GTK_DIALOG (p_dialog));
	gtk_widget_destroy (p_dialog);
	return;
}


/* Fonction de callback pour pour le menu "A propos"
 * Auteur: Mathieu Pellegrin
 * Entrée: Rien
 * Sortie: Rien
 */
void cb_menu_about (void)
{
	GError *error = NULL;
	GIOChannel *channel = NULL;

	channel = g_io_channel_new_file ("LICENSE", "r", &error);
	if (channel != NULL)
	{
		char *text = NULL;

		if (g_io_channel_read_to_end (channel, &text, 0, &error) == G_IO_STATUS_NORMAL)
		{
			GtkWidget *p_dialog = gtk_about_dialog_new ();
			GdkPixbuf *logo = gdk_pixbuf_new_from_file("logo.png", NULL);
			const gchar *authors[] = {"Mathieu Pellegrin",NULL};
			const gchar *artists[] = {"Nicolas Pellegrin",NULL};

			gtk_about_dialog_set_logo(GTK_ABOUT_DIALOG (p_dialog), logo);
			gtk_about_dialog_set_name(GTK_ABOUT_DIALOG (p_dialog), "Projet de programmation IN402");
			gtk_about_dialog_set_copyright(GTK_ABOUT_DIALOG (p_dialog), "(c) Mathieu PELLEGRIN 2009");
			gtk_about_dialog_set_license(GTK_ABOUT_DIALOG (p_dialog), text);
			gtk_about_dialog_set_authors(GTK_ABOUT_DIALOG (p_dialog), authors);
			gtk_about_dialog_set_artists(GTK_ABOUT_DIALOG (p_dialog), artists);
			gtk_about_dialog_set_website(GTK_ABOUT_DIALOG (p_dialog), "http://mathedit.free.fr/");
			/*gtk_about_dialog_set_comments(GTK_ABOUT_DIALOG (p_dialog), "This program comes with ABSOLUTELY NO WARRANTY; This is free software, and you are welcome to redistribute it under certain conditions.\nYou should have received a copy of the GNU General Public License along with this program.\nIf not, see <http://www.gnu.org/licenses/>.");*/

			gtk_dialog_run (GTK_DIALOG (p_dialog));
			g_free(text);
			g_object_unref(logo);

			if (g_io_channel_shutdown (channel, FALSE, &error) == G_IO_STATUS_ERROR)
			{
				GtkWidget *p_dialog = NULL;

				p_dialog = gtk_message_dialog_new(NULL, GTK_DIALOG_MODAL, GTK_MESSAGE_INFO, GTK_BUTTONS_OK, error->message);
				gtk_dialog_run (GTK_DIALOG (p_dialog));
				gtk_widget_destroy (p_dialog);
			}
		}
	}
	if (error != NULL)
	{
		GtkWidget *p_dialog = NULL;

		p_dialog = gtk_message_dialog_new(NULL, GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, error->message);
		gtk_dialog_run (GTK_DIALOG (p_dialog));
		gtk_widget_destroy (p_dialog);
	}
	return;
}

