/**
 *      selection_jeu_gtk.c
 *      Contient les fonctions pour lancer la partie en GTK
 *
 *      Mathieu Pellegrin
 *
 *      2009
 *
 **/

/* Inclusions standard */
#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>

/* Inclusions du programme */
#include "../../typedef.h"
#include "gtkdef.h"
#include "../../common.h"

#include "../common_interface.h"
#include "interface_gtk.h"
#include "menu.h"
#include "callback.h"
#include "partie_gtk.h"
#include "selection_jeu_gtk.h"


/* Choix du jeu en GTK
 * Auteur: Mathieu Pellegrin
 * Entrée: Les arguments du programme
 * Sortie: Rien (interface)
 */
void selection_jeu_gtk(int argc, char **argv)
{
	GtkWidget *p_window = NULL;
	GtkWidget *p_main_box = NULL;
	GtkWidget *valider = NULL;
	GtkWidget *annuler = NULL;
	GtkWidget *p_hpaned = NULL;
	GtkWidget *p_left_box = NULL;
	GtkWidget *p_right_box = NULL;

	/*GtkWidget *pieces[tailleDamier][tailleDamier];*/
	Tjeu partie = NULL;

	init_jeu(&partie);

	gtk_init (&argc, &argv);

	p_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_resizable(GTK_WINDOW(p_window),0);
	g_signal_connect (G_OBJECT (p_window), "destroy", G_CALLBACK (cb_quit), partie);

	gtk_widget_show (p_window);

	gtk_window_set_title (GTK_WINDOW (p_window), "Projet de programmation IN402 - Jeu de dames");

	/*gtk_window_maximize (GTK_WINDOW (p_window));*/

	/* Creation du conteneur principal */
	p_main_box = gtk_vbox_new(FALSE, 0);
	gtk_container_add (GTK_CONTAINER (p_window), p_main_box);

	init_menu(p_main_box, partie);

	p_left_box = gtk_vbox_new(0,0);
	p_right_box = gtk_vbox_new(0,0);
/*	p_hpaned = gtk_hpaned_new();

	gtk_box_pack_start(GTK_BOX (p_main_box), p_hpaned, TRUE, TRUE, 0);
	gtk_paned_add1(GTK_PANED(p_hpaned), p_left_box);
	gtk_paned_add2(GTK_PANED(p_hpaned), p_right_box);
*/
	p_hpaned = gtk_hbox_new(0,0);
	gtk_box_pack_start(GTK_BOX (p_main_box), p_hpaned, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX (p_hpaned), p_left_box, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX (p_hpaned), p_right_box, TRUE, TRUE, 0);

	{
		GtkWidget* p_tree_view;
		GtkCellRenderer* p_render;
		GtkTreeViewColumn* p_column;
		GtkWidget* p_scrolled_window;

		p_scrolled_window = gtk_scrolled_window_new (NULL, NULL);
		gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW (p_scrolled_window), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

		partie->cases_selection = gtk_list_store_new(1, G_TYPE_STRING);
		p_tree_view = gtk_tree_view_new_with_model (GTK_TREE_MODEL (partie->cases_selection));
		p_render = gtk_cell_renderer_text_new();
		p_column = gtk_tree_view_column_new_with_attributes("Cases séléctionnées",p_render,"text",0,NULL);
		gtk_tree_view_append_column(GTK_TREE_VIEW(p_tree_view), p_column);
		gtk_box_pack_start(GTK_BOX (p_left_box), p_scrolled_window, TRUE, TRUE, 0);
		/*gtk_box_pack_start(GTK_BOX (p_left_box), p_tree_view, TRUE, TRUE, 0);*/
		gtk_container_add (GTK_CONTAINER (p_scrolled_window), p_tree_view);
	}

	init_tableau(p_right_box, partie);

	valider = gtk_button_new_from_stock(GTK_STOCK_APPLY);
	/*gtk_container_add(GTK_CONTAINER(p_main_box), valider);*/
	g_signal_connect(valider, "clicked",G_CALLBACK(valider_coup), partie);
	gtk_box_pack_start(GTK_BOX (p_right_box), valider, FALSE, FALSE, 2);
	partie->bouton_valider = valider;

	annuler = gtk_button_new_from_stock(GTK_STOCK_CLEAR);
	/*gtk_container_add(GTK_CONTAINER(p_main_box), valider);*/
	g_signal_connect(annuler, "clicked",G_CALLBACK(annuler_coup), partie);
	gtk_box_pack_start(GTK_BOX (p_left_box), annuler, FALSE, FALSE, 2);

	partie->statusbar = gtk_statusbar_new();
	partie->statusbar_context = gtk_statusbar_get_context_id(GTK_STATUSBAR(partie->statusbar), "main_status");
	/*gtk_container_add(GTK_CONTAINER(p_main_box), p_status_bar);*/
	gtk_statusbar_set_has_resize_grip(GTK_STATUSBAR(partie->statusbar),0);
	gtk_box_pack_start(GTK_BOX (p_main_box), partie->statusbar, FALSE, FALSE, 2);
	gtk_statusbar_push(GTK_STATUSBAR(partie->statusbar), partie->statusbar_context, "Début de partie");

	/*gtk_box_pack_start (GTK_BOX (p_main_box), GTK_WIDGET (), FALSE, FALSE, 0);*/

	/* Affichage de la fenetre principale */
	gtk_widget_show_all (p_window);

	update_status(partie);

	gtk_main();

}
