/**
 *      selection_jeu_texte.c
 *      Contient les fonctions pour lancer la partie en mode texte
 *
 *      Mathieu Pellegrin
 *
 *      2009
 *
 **/

/* Inclusions standard */
#include <stdlib.h>
#include <stdio.h>

/* Inclusions du programme */
#include "../../typedef.h"
#include "../../common.h"
#include "../../jeu/gestion_sauvegarde.h"
#include "../../jeu/gestion_liste.h"
#include "../../jeu/damier.h"
#include "../common_interface.h"
#include "interface_texte.h"
#include "partie_texte.h"
#include "selection_jeu_texte.h"


/* Procédure permettant de lancer la partie en mode texte
 * Auteur: Mathieu Pellegrin
 * Entrée: Les arguments du programme
 * Sortie: Rien
 */
void selection_jeu_texte(int argc, char **argv)
{
	char choix;
	Tliste sauv = NULL;
	Tdamier damier;

	(void)argc;
	(void)argv;

	init_damier(damier);
	init_liste(&sauv);

	printf("Jouer ('J') ou Restaurer une partie ('R') ? ");
	scanf("%c",&choix);
	viderTamponEntree();

	switch (choix)
	{
		case 'j':
		case 'J':
			printf("Type de partie: Humain vs Humain ('H'), Humain vs IA ('J'), IA vs IA ('I') ? ");
			scanf("%c",&choix);
			viderTamponEntree();
			switch (choix)
			{
				case 'h':
				case 'H':
					jeu_humain_vs_humain(sauv);
				break;

				case 'j':
				case 'J':
					jeu_humain_vs_ia(sauv);
				break;

				case 'i':
				case 'I':
					jeu_ia_vs_ia(sauv);
				break;
			}
		break;

		case 'r':
		case 'R':
			printf("Jouer la partie après restauration (O/N) ? ");
			scanf("%c",&choix);
			viderTamponEntree();

			switch (choix)
			{
				case 'o':
				case 'O':
					charge_liste_coup(&sauv,FICHIER_SAUVEGARDE);

					printf("Type de partie: Humain va Humain ('H'), Humain vs IA ('J'), IA vs IA ('I') ? ");
					scanf("%c",&choix);
					viderTamponEntree();

					switch (choix)
					{
						case 'h':
						case 'H':
							jeu_humain_vs_humain(sauv);
						break;

						case 'j':
						case 'J':
							jeu_humain_vs_ia(sauv);
						break;

						case 'i':
						case 'I':
							jeu_ia_vs_ia(sauv);
						break;
					}
				break;

				case 'n':
				case 'N':
				default:
					charge_liste_coup(&sauv,FICHIER_SAUVEGARDE);
					lit_sauvegarde(sauv,damier);
					free_liste(&sauv);
				break;
			}

		break;
	}

}
