/**
 *      gestion_sauvegarde.c
 *      Contient les fonctions de sauvegarde/restauration de partie
 *
 *      Mathieu Pellegrin
 *
 *      2009
 *
 **/

/* Inclusions standard */
#include <stdlib.h>
#include <stdio.h>

/* Inclusions du programme */
#include "../typedef.h"
#include "../common.h"
#include "gestion_liste.h"
#include "gestion_sauvegarde.h"


/* Sauve le coup dans la liste de coups joués au cours de la partie
 * Auteur: Mathieu Pellegrin
 * Entrée: La liste et le coup
 * Sortie: Le coup est ajouté
 */
void sauve_coup(Tliste *liste, Tcoup cp)
{
	Tliste tmp = NULL;
	Tliste tmpcoup = NULL;
/*printf("%d %d %d %d %p %p\n",cp.depart.x,cp.depart.y,cp.arrivee.x,cp.arrivee.y,(void*)cp.suiv,(void*)cp.multiple);*/
	ajoute_element(liste,cp);

	tmp = *liste;
	tmpcoup = cp.multiple;
/*printf("%d %d %d %d %p %p\n",tmp->depart.x,tmp->depart.y,tmp->arrivee.x,tmp->arrivee.y,(void*)tmp,(void*)tmp->multiple);
printf("%p %p\n",(void*)liste,(void*)*liste);*/

	while (tmpcoup!=NULL)
	{
		copie_maillon(tmpcoup, &(tmp->multiple));
		tmpcoup = tmpcoup->multiple;
		tmp = tmp->multiple;
		/*printf("%d %d %d %d %p %p\n",tmp->depart.x,tmp->depart.y,tmp->arrivee.x,tmp->arrivee.y,(void*)tmp,(void*)tmp->multiple);*/
	}
}


/* Sauve la liste dans le fichier spécifié
 * Auteur: Mathieu Pellegrin
 * Entrée: La liste et le fichier
 * Sortie: Le coup est ajouté
 */
void sauve_liste_coup(Tliste liste, char* fichier)
{
	FILE* fp;
	Tliste mult = NULL;

	fp = fopen(fichier,"w");
	while (liste!=NULL)
	{
		fprintf(fp,"%d %d",(liste->depart).x,(liste->depart).y);

		mult = liste;
		while (mult != NULL)
		{
			fprintf(fp," %d %d",(mult->arrivee).x,(mult->arrivee).y);
			mult = mult->multiple;
		}
		fprintf(fp,"\n");
		liste = liste->suiv;
	}
	fclose(fp);
}



/* Charge la partie sauvegardée depuis le fichier
 * Auteur: Mathieu Pellegrin
 * Entrée: La liste et le fichier
 * Sortie: Le coup est ajouté
 */
void charge_liste_coup(Tliste *liste, char* fichier)
{
	FILE* fp;
	Tcoup *tmp;
	Tcoup *tmpmult;
	int departx, departy, arriveex, arriveey;

	*liste = NULL;

	fp = fopen(fichier,"r");
	while (fscanf(fp,"%d %d %d %d",&departx,&departy,&arriveex,&arriveey)==4)
	{
		tmp = (Tcoup*)malloc(sizeof(Tcoup));
		(tmp->depart).x = departx;
		(tmp->depart).y = departy;
		(tmp->arrivee).x = arriveex;
		(tmp->arrivee).y = arriveey;
		tmp->suiv = *liste;
		tmp->multiple = NULL;
		*liste = tmp;

		while (fgetc(fp) != '\n' && fscanf(fp,"%d %d",&arriveex,&arriveey)==2)
		{
			tmpmult = (Tcoup*)malloc(sizeof(Tcoup));
			(tmpmult->depart).x = (tmp->arrivee).x;
			(tmpmult->depart).y = (tmp->arrivee).y;
			(tmpmult->arrivee).x = arriveex;
			(tmpmult->arrivee).y = arriveey;
			tmpmult->suiv = NULL;
			tmpmult->multiple = NULL;
			tmp->multiple = tmpmult;
			tmp = tmpmult;
		}
	}
	fclose(fp);
}
