/**
 *      jeu.h
 *      Contient les fonctions pour la gestion du jeu
 *
 *      Mathieu Pellegrin
 *
 *      2009
 *
 **/

/* Inclusions standard */
#include <stdlib.h>
#include <stdio.h>

/* Inclusions du programme */
#include "../typedef.h"
#include "../common.h"
#include "coups.h"
#include "jeu.h"


/* Détermine la fin de la partie
 * Auteur: Mathieu Pellegrin
 * Entrée: Le damier, et le coup joué précédemment
 * Sortie: 0 si la partie n'est pas terminée et 1 sinon
 */
int fin_partie(Tdamier dm, Tcoup cp)
{
	static int n = 0;
	int stop = 0;
	int x,y;

	n++;

	stop = 1;
	for (x=0; x<tailleDamier && stop; x++)
		for (y=0; y<tailleDamier && stop; y++)
				if (dm[x][y].coul != 'V' && dm[x][y].piece == 'P')
					stop = 0;

	return (n>500 || stop || jeu_bloque(dm,'B') || jeu_bloque(dm,'N'));
	n = cp.depart.x;
}
