/**
 *      main.c
 *      Contient le programme principal
 *
 *      Mathieu Pellegrin
 *
 *      2009
 *
 **/

/* Inclusions standard */
#include <stdlib.h>
#include <stdio.h>

/* Inclusions du programme */
#include "typedef.h"
#include "common.h"
#include "jeu/damier.h"
#include "jeu/pieces.h"
#include "jeu/coups.h"
#include "jeu/gestion_liste.h"
#include "jeu/gestion_sauvegarde.h"
#include "jeu/jeu.h"
#include "interface/common_interface.h"
#if INTERFACE == INTERFACE_TEXTE
#include "interface/texte/interface_texte.h"
#include "interface/texte/selection_jeu_texte.h"
#endif
#if INTERFACE == INTERFACE_GTK
#include "interface/gtk/selection_jeu_gtk.h"
#endif


int main(int argc, char *argv[])
{
	#if INTERFACE == INTERFACE_TEXTE
	selection_jeu_texte(argc, argv);
	#endif
	#if INTERFACE == INTERFACE_GTK
	selection_jeu_gtk(argc, argv);
	#endif

	return 0;
}
