/**
 *      typedef.h
 *      Définition des types
 *
 *      Mathieu Pellegrin
 *
 *      2009
 *
 **/

#ifndef H_TYPES
#define H_TYPES

#define tailleDamier 10

#define INTERFACE_TEXTE 1
#define INTERFACE_GTK 2
#define INTERFACE 1

#define DEBUG_LVL 0

#define MINMAX_INFINITE 10000
#define MINMAX_PROFMAX 5

#define FICHIER_SAUVEGARDE "save/partie.sav"

/* piece : 'P'ion ou 'D'ame */
typedef char Tpiece;

/* couleur :  'B'lanc,  'N'oir ou  'V'ide */
typedef char Tcouleur;

/* contenu d'une case */
typedef struct
{
	Tcouleur coul;
	Tpiece piece;
} Tcase;

/* damier : la case d'indice [0][0] désigne la case (1,A) */
/* c'est à dire la case sur la colonne A et la rangée 1 */
typedef Tcase Tdamier[tailleDamier][tailleDamier];

/* coordonnees de case dans le damier */
typedef struct { int x, y; } Tcoord;

/* liste de coups */
typedef struct quad
{
	Tcoord depart, arrivee;
	struct quad *suiv, *multiple;
} Tcoup;

typedef Tcoup *Tliste;

#endif
